# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.entity_calculation_property_base import EntityCalculationPropertyBase
from typing import Optional, Set
from typing_extensions import Self

class EntityCalculationPropertyAllIntervals(BaseModel):
    """
    EntityCalculationPropertyAllIntervals
    """ # noqa: E501
    unit: StrictStr
    var_1h: Optional[EntityCalculationPropertyBase] = Field(default=None, alias="1h")
    var_1d: Optional[EntityCalculationPropertyBase] = Field(default=None, alias="1d")
    var_1w: Optional[EntityCalculationPropertyBase] = Field(default=None, alias="1w")
    var_1m: Optional[EntityCalculationPropertyBase] = Field(default=None, alias="1m")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["unit", "1h", "1d", "1w", "1m"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EntityCalculationPropertyAllIntervals from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_1h
        if self.var_1h:
            _dict['1h'] = self.var_1h.to_dict()
        # override the default output from pydantic by calling `to_dict()` of var_1d
        if self.var_1d:
            _dict['1d'] = self.var_1d.to_dict()
        # override the default output from pydantic by calling `to_dict()` of var_1w
        if self.var_1w:
            _dict['1w'] = self.var_1w.to_dict()
        # override the default output from pydantic by calling `to_dict()` of var_1m
        if self.var_1m:
            _dict['1m'] = self.var_1m.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EntityCalculationPropertyAllIntervals from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "unit": obj.get("unit"),
            "1h": EntityCalculationPropertyBase.from_dict(obj["1h"]) if obj.get("1h") is not None else None,
            "1d": EntityCalculationPropertyBase.from_dict(obj["1d"]) if obj.get("1d") is not None else None,
            "1w": EntityCalculationPropertyBase.from_dict(obj["1w"]) if obj.get("1w") is not None else None,
            "1m": EntityCalculationPropertyBase.from_dict(obj["1m"]) if obj.get("1m") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


